
# import imaplib
import notimap
imaplib = notimap
import string
from base64 import decodestring, encodestring
from AccessControl.User import BasicUser


class imapUser(BasicUser):
 
    def __init__(self, name, password, roles, domains):
        self.name   =name
        self.__     =password
        self.roles  =filter(None, map(string.strip, 
                                      string.split(roles, ',')))
        self.domains=filter(None, map(string.strip, 
                                      string.split(domains, ',')))

    def getUserName(self):
        return self.name

    def _getPassword(self):
        return self.__

    def getRoles(self):
        return self.roles
    
    def getDomains(self):
        return self.domains

        

class ConnectionManager:
    """ The connection manager manages all of the connections and
    requests requests for NotMail.  NotMail methods use the CM to
    return specific data to the UI.
    """

    def __init__(self, server, port, REQUEST=None):
	""" CM's get instanciated by NotMail """
	self.server = server
	self.port = port
	self.connections = {}  # the cache maps usernames to connections

    def validate(self, request, auth='', roles=None):

        if 'NotMail' not in roles:
            return None

        parent=request['PARENTS'][0]

        # Only do basic authentication
        if string.lower(auth[:6])!='basic ':
            return None
        name,password=tuple(string.split( 
            decodestring(string.split(auth)[-1]), ':'))

        # Create user object
        user=imapUser(name, password, 'NotMail', '')
        if not self.connect(user):
            return None
        # We need the user to be able to acquire!
        # user=user.__of__(self)

        # Try to authorize user
        #if user.allowed(parent, roles):
        #    return user
        #return None
        return user

    def connect(self, user):
	""" If the user auths, return the conn object, otherwise none"""
	# check the cache
	uname = user.getUserName()
	if self.connections.has_key('uname'):
	    return self.connections['uname']
	# try imap
	try:
	    conn = Connection(self.server, self.port, user)
	except:
	    # no good
	    return None
	# good, cache connection
	self.connections['uname'] = conn
	return conn


class Connection:
    """ Used by #tree """

    def __init__(self, server, port, user):
	""" """
	self.connection = notimap.IMAP4(server, port)
	self.connection.login(user.getUserName(), user._getPassword())
	self.user = user
	


    def tpValues(self):
        """ Notes:

        The first level of breakdown from a connection is a Namespace.
        This method returns a list of Namespace objects.
        """
        nspaceseps = []  # hook for seperators
	nspaces = []  # namespaces

	n = string.strip(self.connection.namespace()[1][0])
	start = 0
	end = len(n)
	while 1:
	    # find the first '(('
	    x = string.find(n, '((', start, end)
	    if x == -1:
		break
	    start = x
            # find it's matching ))
	    y = string.find(n, '))', start, end)
	    start = y
	    nsetstring = (n[x+2:y])
            nset = string.split(nsetstring, ')(')
            for i in nset:
                l = len(i)
                p = string.find(i, '"', 1, l)
                # snarf out the namespace name
                nspace = i[1:p]
                if not nspace:
                    # something more useful than blank...
                    nspace = "Your Folders/"
                p = string.find(i, '"', p+1, l)
                # snarf out the namespace seperator
                nspacesep = i[p+1:string.find(i, '"', p+1, l)]
                # seperators currently aren't used (oops)
                nspaceseps.append( (nspace, nspacesep) )
                nspaces.append(Namespace(nspace, self.connection))

	return nspaces


class Namespace:
    """ """

    def __init__(self, nspace, conn):
	self.id = nspace
	self.connection = conn
	self.icon = "misc_/NotMail/folder"

    def tpId(self):
        """ """
        return self.id

    def tpValues(self):
        """ Notes:
        The second level of breakdown in a Connection (below
        namespaces) are Folders.  If an item is flagged Noselect it is 
        another Folder.  If it is marked Noinferiors it is an item of
        some sort:
        """

        if self.id == "Your Folders/":
            typ, boxes = self.connection.list("", '"%%"')
        else:
            typ, boxes = self.connection.list("", ('"%s%%"' % self.id))

        contentnames = []

        flgs = []
	for i in boxes:
            if not i:
                break
            tmp = string.split(i, '"/"')
            last = string.strip(tmp[(len(tmp)-1)])
            if last[0] == '"':
                last = last[1:(len(last)-1)]

            tflgs = string.split(string.strip(tmp[0]), ' ')
            for j in tflgs:
                flgs.append(j[2:])

            if "NoSelect" in flgs:
                contentnames.append(imapFolder(
                    last, flgs, self.connection))
            elif "NoInferiors" in flgs:
                contentnames.append(imapItem(
                    last, flgs, self.connection))
            else:
                contentnames.append(imapFolder(
                    last, flgs, self.connection))

	return contentnames

class imapFolder:
    """ """

    def __init__(self, name, flgs, conn):
	self.id = name
        self.flags = flgs
	self.connection = conn
	self.icon = "misc_/NotMail/folder"

    def tpId(self):
        """ """
        return self.id

    def tpValues(self):
        """ Folders are recursive, they return a list of mixed folders 
        and items.
        """

	tpy, contents = self.connection.list("", ('"%s/%%"' % self.id))
        contentnames = []
        flgs = []
        for i in contents:
            if not i:
                break
            tmp = string.split(i, '"/"')
            last = string.strip(tmp[(len(tmp)-1)])
            if last[0] == '"':
                last = last[1:(len(last)-1)]

            tflgs = string.split(string.strip(tmp[0]), ' ')
            for j in tflgs:
                flgs.append(j[2:])

            if "NoSelect" in flgs:
                contentnames.append(imapFolder(
                    last, flgs, self.connection))
            elif "NoInferiors" in flgs:
                contentnames.append(imapItem(
                    last, flgs, self.connection))
            else:
                contentnames.append(imapFolder(
                    last, flgs, self.connection))

        return contentnames


class imapItem:
    """ """

    def __init__(self, name, flgs, conn):
        self.id = name
        self.connection = conn
        self.icon = "misc_/NotMail/item"

    def tpId(self):
        """ """
        return self.id















